﻿using Microsoft.Win32.SafeHandles;
using System;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Security;
using System.Security.Permissions;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            AllocIntPtr();
            AllocSafeHandle();
        }

        private static void AllocIntPtr()
        {
            IntPtr memPtr = Marshal.AllocHGlobal(0x100);

            if (memPtr != IntPtr.Zero)
            {
                Marshal.FreeHGlobal(memPtr);
            }
        }

        private static void AllocSafeHandle()
        {
            int intLen = 100;

            using (SafeLocalAllocArrayHandle safeHandle = SafeLocalAllocArrayHandle.Alloc(sizeof(int) * intLen))
            {
                Span<int> intarr = safeHandle.AsSpan<int>();
                for (int i = 0; i < intLen; i++)
                {
                    intarr[i] = i;
                }

                Console.WriteLine(intarr[0]);
                Console.WriteLine(intarr[99]);
            }
        }
    }

    [SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode = true)]
    public sealed class SafeLocalAllocArrayHandle :
        SafeHandleZeroOrMinusOneIsInvalid
    {
        [DllImport("kernel32.dll")]
        private static extern SafeLocalAllocArrayHandle LocalAlloc(
           LMEM uFlags, IntPtr sizetdwBytes);

        int _size = 0;

        private SafeLocalAllocArrayHandle() : base(true)
        {
        }

        public static SafeLocalAllocArrayHandle Alloc(int size)
        {
            SafeLocalAllocArrayHandle handle = LocalAlloc(LMEM.ZEROINIT, new IntPtr(size));

            if (handle.IsInvalid == false)
            {
                handle._size = size;
            }

            return handle;
        }

        public unsafe Span<T> AsSpan<T>() where T : unmanaged
        {
            int arrSize = _size / sizeof(T);
            Span<T> arr = new Span<T>(this.handle.ToPointer(), arrSize);
            return arr;
        }

        protected override bool ReleaseHandle()
        {
            return LocalFree(handle) == IntPtr.Zero;
        }

        [SuppressUnmanagedCodeSecurity]
        [ReliabilityContract(Consistency.WillNotCorruptState, Cer.Success)]
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern IntPtr LocalFree(IntPtr handle);


        public enum LMEM
        {
            LHND = 0x42,

            FIXED = 0,
            MOVEABLE = 0x2,
            ZEROINIT = 0x40,
        }
    }
}
